FROM mcr.microsoft.com/dotnet/aspnet:10.0 AS base
ARG APP_UID=1000
USER $APP_UID
WORKDIR /app
EXPOSE 8080
EXPOSE 8081

FROM mcr.microsoft.com/dotnet/sdk:10.0 AS build
ARG BUILD_CONFIGURATION=Release
WORKDIR /src
COPY ["UniVerse.Api/UniVerse.Api.csproj", "UniVerse.Api/"]
COPY ["UniVerse.Application/UniVerse.Application.csproj", "UniVerse.Application/"]
COPY ["UniVerse.Domain/UniVerse.Domain.csproj", "UniVerse.Domain/"]
COPY ["UniVerse.Infrastructure/UniVerse.Infrastructure.csproj", "UniVerse.Infrastructure/"]
RUN dotnet restore "UniVerse.Api/UniVerse.Api.csproj"
COPY . .
WORKDIR "/src/UniVerse.Api"
RUN dotnet build "./UniVerse.Api.csproj" -c $BUILD_CONFIGURATION -o /app/build

FROM build AS publish
ARG BUILD_CONFIGURATION=Release
RUN dotnet publish "./UniVerse.Api.csproj" -c $BUILD_CONFIGURATION -o /app/publish /p:UseAppHost=false

FROM base AS final
WORKDIR /app
COPY --from=publish /app/publish .
ENTRYPOINT ["dotnet", "UniVerse.Api.dll"]
